// gettime.cc

#include "dtime.h"

////////////////////////////////////////////////////////////
// Constructor:
////////////////////////////////////////////////////////////

DTime::DTime() {
    dt = (time_t)(-1);      // No current time
}

////////////////////////////////////////////////////////////
// Add seconds to the current time in this->dt :
////////////////////////////////////////////////////////////

DTime &
DTime::operator+=(long secs) {
    dt += (time_t) secs;
    return *this;
}

////////////////////////////////////////////////////////////
// Subtract seconds to the current time in this->dt :
////////////////////////////////////////////////////////////

DTime &
DTime::operator-=(long secs) {
    dt -= (time_t) secs;
    return *this;
}

////////////////////////////////////////////////////////////
// Return current time :
////////////////////////////////////////////////////////////

time_t
DTime::getTime() {
    return ::time(&dt);
}

////////////////////////////////////////////////////////////
// Allow the caller to plug-in a time value :
////////////////////////////////////////////////////////////

time_t
DTime::putTime(time_t dt) {
    return this->dt = dt;
}

// End gettime.cc
